﻿

<script type="text/javascript">
    var _height_Window  = $(window).height();
    var _height_Header  = $('.iq-top-navbar').height();
    var _height_Title   = $('#box_title_table').height();
    var _height_Footer  = $('.iq-footer').height();

    // console.log(_height_Window);
    // console.log(_height_Header);
    // console.log(_height_Title);
    // console.log(_height_Footer);
    /* Config scroll table - Xoá comment để kích hoạt */
    var flag_fixed = false;
    if($(window).width() > 760){
        $('.iq-card-body').height(_height_Window - _height_Header  - _height_Footer - 76 - 25);
        flag_fixed = true;
    }else{
        $('.iq-card-body').height(_height_Window - _height_Header - 15);
        if($(window).width() > 375){
            flag_fixed = true;
        }else{
            flag_fixed = false;
        }
    }
    $('.IdLoaiVanBan').select2();

    function load_danhsach_bochungtu() {
        var url = new URL(window.location.href);
        var c = '';
        if (url.searchParams.get("TrangThai"))
            c = url.searchParams.get("TrangThai");
        console.log('@Url.Action("GetAllVanBan", "VanPhongSo")'+'/' + c);

        $.ajax({
            url: '@Url.Action("GetAllVanBan", "VanPhongSo")'+'/' + c,
            type: 'GET',
            data: {TrangThai : c},
            dataType: 'json'
        })
            .done(function (response2) {
                console.log(response2);
            $('#gridContainer').dxDataGrid({
                dataSource: response2,
                keyExpr: 'Id',
                showBorders: true,
                showRowLines: true,
                paging: {
                    enabled: false
                },
                columnAutoWidth: true,
                columnHidingEnabled: true,
                allowColumnResizing: true,
                columnFixing: {
                    enabled: true
                },
                filterRow: {
                    visible: true,
                    applyFilter: 'auto',
                },
                // filterPanel: { visible: true },
                headerFilter: { visible: true },
                columns:
                    [

                        {
                            headerCellTemplate: function(container) {
                                container.text('STT').parent().css({fontWeight: 'bold', backgroundColor: '#c5d3dd'});
                            },
                            width: 50,
                            //dataField: "STT",
                            alignment: "center",
                            cellTemplate: function (container, options) {
                                let _stt = options.rowIndex + 1;
                                $(container).html(_stt);
                            }
                        },
                        {
                            headerCellTemplate: function (container) {
                                container.text('Mã văn bản').parent().css({ fontWeight: 'bold', backgroundColor: '#c5d3dd' });
                            },
                            cellTemplate: function (container, options) {
                                let link_detail = `<a href="/vanphongso/bochungtu_chitiet/${options.data.Id}" target="">${options.value}</a>`;
                                $(container).html(link_detail);
                            },
                            dataField: "MaVanBan",
                            alignment: "center",
                            width: 120,
                            caption : "Mã văn bản"
                        },
                        {
                            headerCellTemplate: function(container) {
                                container.text('Tiêu đề').parent().css({fontWeight: 'bold', backgroundColor: '#c5d3dd'});
                            },
                            dataField: "TieuDe",
                            width: 300,
                            alignment: "left",
                            caption : "Tiêu đề"
                        },
                        //{
                        //    headerCellTemplate: function(container) {
                        //        container.text('Ghi chú').parent().css({fontWeight: 'bold', backgroundColor: '#c5d3dd'});
                        //    },
                        //    dataField: "GhiChu",
                        //    cellTemplate: function (container, options) {
                        //        $(container).html(options.value);
                        //    },
                        //    caption : "Ghi chú"
                        //},

                        {
                            headerCellTemplate: function (container) {
                                container.text('Đơn Vị').parent().css({ fontWeight: 'bold', textAlign: 'center', backgroundColor: '#c5d3dd' });
                            },
                            width: 250,
                            dataField: "TenDonVi",
                            alignment: "center",
                            cellTemplate: function (container, options) {
                                $(container).html(options.value);
                            },
                            caption: "Đơn vị"
                        },
                        {
                            headerCellTemplate: function (container) {
                                container.text('Trạng thái').parent().css({ fontWeight: 'bold', textAlign: 'center', backgroundColor: '#c5d3dd' });
                            },
                            width: 100,
                            dataField: "TrangThai",
                            alignment: "center",
                            cellTemplate: function (container, options) {
                                //console.log(options);
                                let text_Color_TrangThai = '';
                                if (options.data.TrangThai == 'MoiTao') {
                                    text_Color_TrangThai = `<span class="badge badge-secondary">Mới tạo</span>`;
                                } else if (options.data.TrangThai == 'HoanTat') {
                                    text_Color_TrangThai = `<span class="badge badge-success">Hoàn tất</span>`;
                                } else if (options.data.TrangThai == 'DaHuy') {
                                    text_Color_TrangThai = `<span class="badge badge-danger">Đã hủy</span>`;
                                } else if (options.data.TrangThai == 'DaKhoa') {
                                    text_Color_TrangThai = `<span class="badge badge-warning">Đã khóa</span>`;
                                }
                                $(container).html("<h5>" + text_Color_TrangThai + "</h5>");
                            },
                            caption: "Trạng thái"
                        },
                        {
                            headerCellTemplate: function(container) {
                                container.text('Ngày tạo').parent().css({fontWeight: 'bold', textAlign: 'center', backgroundColor: '#c5d3dd'});
                            },
                            width: 100,
                            alignment: "center",
                            dataField: "NgayTao",
                            dataType: 'date',
                            format: 'dd/MM/yyyy',
                            caption : "Ngày tạo"
                        },
                        {
                            headerCellTemplate: function(container) {
                                container.text('Người tạo').parent().css({fontWeight: 'bold', textAlign: 'center', backgroundColor: '#c5d3dd'});
                            },
                            width: 100,
                            dataField: "TenNguoiTao",
                            alignment: "center",
                            cellTemplate: function (container, options) {
                                $(container).html(options.value);
                            },
                            caption : "Người tạo"
                        },
                        {
                            headerCellTemplate: function(container) {
                                container.text('').parent().css({fontWeight: 'bold', textAlign: 'center', backgroundColor: '#c5d3dd'});
                            },
                            dataField: "",
                            width: 150,
                            alignment: "center",
                            cellTemplate: function (container, options) {
                                let text_Color_TrangThai = ``;
                                if (options.data.TrangThai == "MoiTao") {
                                    text_Color_TrangThai = `
                                            <a class="badge badge-danger action_huy_chung_tu" href="#" data-id="${options.data.Id}" data-tieude="${options.data.TieuDe}">
                                            <i class="fa fa-times"></i> Huỷ</a></h5>
                                    `;
                                }else if(options.data.TrangThai == "DaKhoa" || options.data.TrangThai == "HoanTat")
                                {
                                    text_Color_TrangThai = `
                                            <h5><a class="badge badge-primary" style="color:white;" data-toggle="modal" data-target="#modal_ChiaSe" data-id="${options.data.Id}" data-mavanban="${options.data.MaVanBan}" data-maqr="${options.data.MaQR}" data-link="${options.data.Link}" data-tieude="${options.data.TieuDe}">
                                            <i class="fa fa-share"></i> Chia sẽ</a>
                                    `;
                                }else if (options.data.TrangThai == "Dahuy")
                                {
                                   
                                }
                                

                                $(container).css({overflow: 'initial'}).html(text_Color_TrangThai);
                            }
                        },
                    ],
                summary: {
                    totalItems:
                        [
                            {
                                column: 'MoTa',
                                summaryType: 'count',
                            }
                        ],
                }
            });
        })
        .fail(function(error) {
            console.log("error", error);
        });
    };
    load_danhsach_bochungtu();

    $(".btnCopyLink").click(function () {
        navigator.clipboard.writeText($('.Link').val());
        $(this).html("Đã copy");
    });
    function printDiv() 
    {

      var divToPrint=document.getElementById('modal-body');
      var newWin=window.open('','Print-Window');
      newWin.document.open();
      newWin.document.write('<html><body onload="window.print()">'+divToPrint.innerHTML+'</body></html>');
      newWin.document.close();
      setTimeout(function(){newWin.close();},10);
    }
    $(".btnInBarcode").click(function () {
        printDiv();
    });
    /* Chia sẽ chứng từ */
    $('#modal_ChiaSe').on('show.bs.modal', function (event) {
        $('#modal_ChiaSe .modal-body').html('');
        var button = $(event.relatedTarget);
        var _id = button.data('id');
        var _mavanban = button.data('mavanban');
        var _tieude = button.data('tieude');
        var _maqr = button.data('maqr');
        var _link = button.data('link');
        var modal = $(this);
        //console.log(_id, _tieude, _maqr);
        var kq_maqr = "";
        if(_maqr){
            kq_maqr = `<img class="img-fluid" width="200" src="${_maqr}" >`;
        }else{
            kq_maqr = `<h3 class="text-danger text-center">CHƯA CÓ MÃ QR</h3>`;
        }
        var _html = `
            <h4 class="text-center mb-1" style="text-align:center"><b class="text-danger">${_mavanban}</b></h4>
            <h4 class="text-center mb-3" style="text-align:center"><b class="text-danger">${_tieude}</b></h4>
            <div class="w-100 text-center" style="text-align:center;display:block;">
                ${kq_maqr}
            </div>
            <div class="w-100 text-center">
                <div class="input-group input-group-md">
                  <input type="hidden" class="form-control Link" value="${_link}" style="font-size:14px;text-align:center;color:blue" readonly/>
                  <input type="hidden" class="form-control Image" value="${_maqr}" style="font-size:14px;text-align:center;color:blue" readonly/>
                </div>
            </div>
        `;
        $('#modal_ChiaSe .modal-body').html(_html);
        // $.ajax({
        //     type : 'POST',
        //     dataType : 'json',
        //     url : _url_,
        //     data : {
        //         id: _id,
        //     },
        //     success : function (res){

        //     },
        //     error : function (){
        //         alert('Có lỗi xảy ra trong quá trình xử lý');
        //     }
        //});
    });
    /* Reset Form modal classify 1*/
    $('#modal_ChiaSe').on('hide.bs.modal', function (event) {
        //$('#modal_ChiaSe .modal-content').html('');
        //alert('Đóng modal nè');
    });

    /* Huỷ chứng từ */
    $("#gridContainer").on('click', '.action_huy_chung_tu', function(e) {
        let _id = $(e.target).attr('data-id');
        let _TieuDe = $(e.target).attr('data-tieude');
        console.log(_id);
        if(_id){
            if(confirm(`Bạn muốn huỷ hồ sơ?\nTiêu đề: ${_TieuDe}`)){
                $.ajax({
                    url: '@Url.Action("HuyPhieu", "VanPhongSo")',
                    type: 'POST',
                    dataType: 'text',
                    data: { Id: _id }
                }).done(function (response) {
                    //console.log(response);
                        swal({
                                    title: "Thành công",
                                    text: "Đã hủy phiếu!",
                                    type: 'success',
                                    confirmButtonColor: "#DD6B55",
                                    showCancelButton: false,
                                },
                                    function (isConfirm) {
                                        if (isConfirm) {
                                            window.location.reload();
                                        }
                                    }
                                );
                });
            }
        }
        // alert(message?: DOMString);
        /* Act on the event */
    });

    /* Valida form Thêm bộ chứng từ */
    (function() {
        'use strict';
        window.addEventListener('load', function() {
            var forms = document.getElementsByClassName('form_Tao_BoChungTu');

            var validation = Array.prototype.filter.call(forms, function(form) {
                form.addEventListener('submit', function(event) {
                    if (form.checkValidity() === false) {
                        event.preventDefault();
                        event.stopPropagation();
                    }else{
                        event.preventDefault();
                        console.log('gọi ajax');
                        let _data = {
                                IdDonVi: $(".form_Tao_BoChungTu .IdDonVi").val(),
                                TieuDe: $(".form_Tao_BoChungTu .TieuDe").val(),
                                NoiDung: $(".form_Tao_BoChungTu .NoiDung").val(),
                                GhiChu: $(".form_Tao_BoChungTu .GhiChu").val(),
                                MaQuyenVanBan: $(".form_Tao_BoChungTu .MaQuyenVanBan").val(),
                                IdLoaiVanBan: $(".form_Tao_BoChungTu .IdLoaiVanBan").val()
                        };
                        console.log(_data);

                        $.ajax({
                            url: '@Url.Action("TaoPhieuDangKy", "VanPhongSo")',
                            type: 'POST',
                            dataType: 'json',
                            data: _data,
                        })
                            .done(function (res) {
                                console.log(res);
                            //console.log("success");
                            $(".form_Tao_BoChungTu .btn_reset").trigger('click');
                            $("#modal_Them_BoChungTu").modal('hide');
                            //load_danhsach_bochungtu();
                            //doNotify("Tạo Phiếu thành công", "success");
                                swal({
                                    title: "Thành công",
                                    text: "Đã tạo thành công, bấm OK để vào chi tiết phiếu!",
                                    type: 'success',
                                    confirmButtonColor: "#DD6B55",
                                    showCancelButton: false,
                                },
                                    function (isConfirm) {
                                        if (isConfirm) {
                                            window.location.href ='@Url.Action("BoChungTu_ChiTiet", "VanPhongSo")' + '/' + res ;
                                        }
                                    }
                                );
                        })
                        .fail(function() {
                            console.log("error");
                        })
                        .always(function() {
                            console.log("complete");
                        });

                    }
                    form.classList.add('was-validated');
                }, false);
            });
        }, false);


    })();
</script>